// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: queries.sql

package queries

import (
	"context"

	"github.com/gofrs/uuid"
	"github.com/jackc/pgx/v5/pgtype"
)

const createMetadataRecord = `-- name: CreateMetadataRecord :exec
INSERT INTO transactionlog.metadata (
    id,
    transaction_id,
    direction,
    group_id,
    metadata
)
VALUES ($1, $2, $3, $4, $5)
`

type CreateMetadataRecordParams struct {
	ID            uuid.UUID
	TransactionID uuid.UUID
	Direction     TransactionlogDirection
	GroupID       string
	Metadata      []byte
}

func (q *Queries) CreateMetadataRecord(ctx context.Context, arg *CreateMetadataRecordParams) error {
	_, err := q.db.Exec(ctx, createMetadataRecord,
		arg.ID,
		arg.TransactionID,
		arg.Direction,
		arg.GroupID,
		arg.Metadata,
	)
	return err
}

const createRecord = `-- name: CreateRecord :exec
INSERT INTO transactionlog.records (
    transaction_id,
    group_id,
    grant_hash,
    direction,
    service_name,
    src_outway_peer_id,
    delegated_src_outway_peer_id,
    delegated_src_delegator_peer_id,
    dest_service_peer_id,
    delegated_dest_service_peer_id,
    delegated_dest_delegator_peer_id,
    created_at
)
VALUES ($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12)
`

type CreateRecordParams struct {
	TransactionID                uuid.UUID
	GroupID                      string
	GrantHash                    string
	Direction                    TransactionlogDirection
	ServiceName                  string
	SrcOutwayPeerID              pgtype.Text
	DelegatedSrcOutwayPeerID     pgtype.Text
	DelegatedSrcDelegatorPeerID  pgtype.Text
	DestServicePeerID            pgtype.Text
	DelegatedDestServicePeerID   pgtype.Text
	DelegatedDestDelegatorPeerID pgtype.Text
	CreatedAt                    pgtype.Timestamptz
}

func (q *Queries) CreateRecord(ctx context.Context, arg *CreateRecordParams) error {
	_, err := q.db.Exec(ctx, createRecord,
		arg.TransactionID,
		arg.GroupID,
		arg.GrantHash,
		arg.Direction,
		arg.ServiceName,
		arg.SrcOutwayPeerID,
		arg.DelegatedSrcOutwayPeerID,
		arg.DelegatedSrcDelegatorPeerID,
		arg.DestServicePeerID,
		arg.DelegatedDestServicePeerID,
		arg.DelegatedDestDelegatorPeerID,
		arg.CreatedAt,
	)
	return err
}

const listMetadataRecords = `-- name: ListMetadataRecords :many
SELECT transaction_id, direction, group_id, metadata FROM transactionlog.metadata as m WHERE m.transaction_ID = $1::uuid
`

type ListMetadataRecordsRow struct {
	TransactionID uuid.UUID
	Direction     TransactionlogDirection
	GroupID       string
	Metadata      []byte
}

func (q *Queries) ListMetadataRecords(ctx context.Context, transactionID uuid.UUID) ([]*ListMetadataRecordsRow, error) {
	rows, err := q.db.Query(ctx, listMetadataRecords, transactionID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListMetadataRecordsRow{}
	for rows.Next() {
		var i ListMetadataRecordsRow
		if err := rows.Scan(
			&i.TransactionID,
			&i.Direction,
			&i.GroupID,
			&i.Metadata,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listRecords = `-- name: ListRecords :many

SELECT r.transaction_id,
    r.group_id,
    r.grant_hash,
    r.direction,
    r.service_name,
    r.src_outway_peer_id,
    r.delegated_src_outway_peer_id,
    r.delegated_src_delegator_peer_id,
    r.dest_service_peer_id,
    r.delegated_dest_service_peer_id,
    r.delegated_dest_delegator_peer_id,
    r.created_at
FROM transactionlog.records as r
WHERE
    r.group_id = $2::text
    AND (cardinality($3::text[]) = 0 OR r.service_name = ANY($3::text[]))
    AND (cardinality($4::uuid[]) = 0 OR r.transaction_id = ANY($4::uuid[]))
    AND (cardinality($5::text[]) = 0 OR r.grant_hash = ANY($5::text[]))
    AND (cardinality($6::text[]) = 0
        OR r.src_outway_peer_id = ANY($6::text[])
        OR r.delegated_src_outway_peer_id = ANY($6::text[])
        OR r.delegated_src_delegator_peer_id = ANY($6::text[])
        OR r.dest_service_peer_id = ANY($6::text[])
        OR r.delegated_dest_service_peer_id = ANY($6::text[])
        OR r.delegated_dest_delegator_peer_id = ANY($6::text[])
    )
    AND ($7::timestamp IS NULL OR r.created_at >= $7::timestamp)
    AND ($8::timestamp IS NULL OR r.created_at <= $8::timestamp)
    AND ($9::uuid = '00000000-0000-0000-0000-000000000000'
        OR ($10::text = 'asc' AND r.transaction_id > $9::uuid)
        OR ($10::text = 'desc' AND r.transaction_id < $9::uuid)
    )
ORDER BY
    CASE
        WHEN $10::text = 'asc' THEN r.transaction_id END ASC,
    CASE
        WHEN $10::text = 'desc' THEN r.transaction_id END DESC
LIMIT $1
`

type ListRecordsParams struct {
	Limit          int32
	GroupID        string
	ServiceNames   []string
	TransactionIds []uuid.UUID
	GrantHashes    []string
	PeerIds        []string
	PeriodStart    pgtype.Timestamp
	PeriodEnd      pgtype.Timestamp
	StartID        uuid.UUID
	OrderDirection string
}

// Copyright © VNG Realisatie 2022
// Licensed under the EUPL
func (q *Queries) ListRecords(ctx context.Context, arg *ListRecordsParams) ([]*TransactionlogRecord, error) {
	rows, err := q.db.Query(ctx, listRecords,
		arg.Limit,
		arg.GroupID,
		arg.ServiceNames,
		arg.TransactionIds,
		arg.GrantHashes,
		arg.PeerIds,
		arg.PeriodStart,
		arg.PeriodEnd,
		arg.StartID,
		arg.OrderDirection,
	)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*TransactionlogRecord{}
	for rows.Next() {
		var i TransactionlogRecord
		if err := rows.Scan(
			&i.TransactionID,
			&i.GroupID,
			&i.GrantHash,
			&i.Direction,
			&i.ServiceName,
			&i.SrcOutwayPeerID,
			&i.DelegatedSrcOutwayPeerID,
			&i.DelegatedSrcDelegatorPeerID,
			&i.DestServicePeerID,
			&i.DelegatedDestServicePeerID,
			&i.DelegatedDestDelegatorPeerID,
			&i.CreatedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
